#!/usr/bin/env python

import urllib
import re

from util import rotateText, UserError
from Node import Node

def latestNum(player):
    page = urllib.urlopen("http://games.ravenblack.net/player/%s.html" % player).read()
    m = re.search('HREF="/warlocks\?num=([0-9]*)', page)
    try: return int(m.groups()[0])
    except: raise UserError("Failed to find game for player %s" % player)

def pageOfNum(num):
    return urllib.urlopen("http://games.ravenblack.net/warlocks?num=%s" % num).read()

def nodeOfNum(num):
    """Highly simplistic parsing to get the node of a warlocks game"""

    node = Node(str(num))
    try: page = pageOfNum(num)
    except: raise UserError("Failed to load page")

    class WarlocksParser:
	def __init__(self, page):
	    self.page = page
	def matchAndAdvance(self, pattern):
	    m = re.search(pattern, self.page)
	    self.page = self.page[m.end():]
	    gs = m.groups()
	    if gs != ():
		if len(gs) == 1: return gs[0]
		else: return gs
    parser = WarlocksParser(page)
    histPat = '</FONT><FONT CLASS=monoturn>([^<]*)</FONT>'
    try:
	parser.matchAndAdvance('quickref.html">')

	turn = parser.matchAndAdvance('<U>Turn (\d*)')

	playerR = parser.matchAndAdvance('<a href="/player/(\w*)\.html"')
	playerRStatus = parser.matchAndAdvance('lightbg>([^<]*)')
	historyRL = parser.matchAndAdvance('LH:'+histPat)
	historyRR = parser.matchAndAdvance('RH:'+histPat)

	playerC = parser.matchAndAdvance('<a href="/player/(\w*)\.html"')
	playerCStatus = parser.matchAndAdvance('lightbg>([^<]*)')
	historyCL = parser.matchAndAdvance('LH:'+histPat)
	historyCR = parser.matchAndAdvance('RH:'+histPat)

	def mungHist(hist):
	    ret = re.sub('&gt;', '>', hist)
	    ret = re.sub('&nbsp;', ' ', ret)
	    return ret
	historyRL = mungHist(historyRL)
	historyRR = mungHist(historyRR)
	historyCL = mungHist(historyCL)
	historyCR = mungHist(historyCR)

	historyRL = historyRL[-7:]
	historyRR = historyRR[-7:]
	historyCL = historyCL[-7:]
	historyCR = historyCR[-7:]

	playerRStatus = re.sub('Health:\s*', 'H:', playerRStatus)
	playerCStatus = re.sub('Health:\s*', 'H:', playerCStatus)

	# TODO: parse further state; aiming info;

    except:
	raise
	#raise UserError("Failed to parse page")

    node.historyR = '\n%s\n%s\n' % (historyRL,historyRR)
    node.historyC = '\n%s\n%s\n' % (historyCL,historyCR)
    node.state = 'R: %s\nC: %s\n' % (playerRStatus, playerCStatus)
    node.notes = 'Ravenblacks %s-%s:\n%s v %s\n' % (num, turn, playerR, playerC)

    return node
