from string import *

def intersperse(list, inter):
    ret = []
    for i,e in enumerate(list):
	if i != 0:
	    ret.append(inter)
	ret.append(e)
    return ret

def attrPlusplus(obj, attr):
    "works like C's obj.attr++, which I hate trying to live without."
    t = getattr(obj,attr)
    setattr(obj,attr,t+1)
    return t

def escapeChars(string, chars):
    ret = ""
    for c in string:
	if c in chars + '\\':
	    ret += '\\'
	ret += c
    return ret

def unescape(string):
    ret = ""
    escaped = False
    for c in string:
	if c == '\\' and not escaped:
	    escaped = True
	else:
	    ret += c
	    escaped = False
    return ret

def _textToRectArray(text, minLength=0, minHeight=0, align="left"):
    if text == '': return []
    lines = text.splitlines()
    # splitlines ignores trailing newlines - fix that:
    if text[len(text)-1] == '\n': lines.append('')
    if len(lines) < minHeight:
	lines += [''] * (minHeight - len(lines))
    l = max(map(len, lines)+[minLength])
    if align == "left":
	lines = [ line + ' '*(l-len(line)) for line in lines ]
    elif align == "right":
	lines = [ ' '*(l-len(line)) + line for line in lines ]
    else:
	raise "unknown align: %s" % align
    return map(list, lines)

def _rectArrayToText(array):
    return join( [ reduce(lambda x,y:x+y, line, '') for line in array ], '\n')
def _rotateRectArray(array):
    if array == []: return []
    array = array[:]
    array.reverse()
    return [ [ line[i] for line in array ] for i in range(len(array[0])) ]

def rotateText(text):
    return _rectArrayToText(_rotateRectArray(_textToRectArray(text)))

def appendRotated(base, appendage):
    appendHeight = max( [ len(r) for r in appendage.splitlines() ] )
    baseArray = _textToRectArray(base, minHeight=appendHeight, align="right" )
    appendArray = _rotateRectArray(_textToRectArray(appendage,
	minLength=len(baseArray)))
    d = dict(enumerate(appendArray))
    return _rectArrayToText( [ baseArray[i] + d.get(i,[]) for i in range(len(baseArray)) ] )

class UserError(Exception):
    def __init__(self, text):
	self.text = text
